DROP FUNCTION IF EXISTS creditos_repartir;
DELIMITER $
CREATE FUNCTION creditos_repartir(frontera INT)
	RETURNS INT
	READS SQL DATA
BEGIN
	DECLARE suma INT;
	SELECT SUM(creditos - frontera) INTO suma FROM alumnos WHERE creditos > frontera;
	
	RETURN suma;
END $
DELIMITER ;

DROP PROCEDURE IF EXISTS reparte;
DELIMITER $
CREATE PROCEDURE reparte(frontera INT)
BEGIN
	DECLARE suma INT;
	DECLARE mover INT;
	DECLARE creditos_actual INT;
	
	SET suma = creditos_repartir(frontera);
	UPDATE alumnos SET creditos = frontera WHERE creditos > frontera;
	
	CREATE TEMPORARY TABLE lista (
		creditos INT,
		cuenta_ini INT,
		cuenta_fin INT,
		
		PRIMARY KEY (creditos)
	) ENGINE=memory;
	
	INSERT INTO lista (creditos, cuenta_ini, cuenta_fin) SELECT creditos, COUNT(*), COUNT(*) FROM alumnos WHERE creditos < frontera GROUP BY creditos;
	SELECT MIN(creditos) INTO creditos_actual FROM lista;
	
	WHILE creditos_actual < frontera AND suma > 0 DO
		SELECT LEAST(suma, cuenta_fin) INTO mover FROM lista WHERE creditos = creditos_actual;
		
		UPDATE lista SET cuenta_fin = cuenta_fin - mover WHERE creditos = creditos_actual;
		INSERT INTO lista (creditos, cuenta_ini, cuenta_fin) VALUES (creditos_actual + 1, 0, mover) ON DUPLICATE KEY UPDATE cuenta_fin = cuenta_fin + mover;
		SET suma = suma - mover;
		
		SET creditos_actual = creditos_actual + 1;
	END WHILE;

	SELECT cuenta_fin - cuenta_ini INTO mover FROM lista WHERE creditos = creditos_actual;
	UPDATE alumnos SET creditos = creditos_actual WHERE creditos < creditos_actual ORDER BY creditos ASC LIMIT mover;
	
	SELECT cuenta_fin - cuenta_ini INTO mover FROM lista WHERE creditos = creditos_actual - 1;
	UPDATE alumnos SET creditos = creditos_actual - 1 WHERE creditos < creditos_actual - 1 ORDER BY creditos ASC LIMIT mover;
END $
DELIMITER ;