DROP FUNCTION IF EXISTS creditos_repartir;
DELIMITER $
CREATE FUNCTION creditos_repartir(frontera INT)
	RETURNS INT
	READS SQL DATA
BEGIN
	DECLARE suma INT;
	SELECT SUM(creditos - frontera) INTO suma FROM alumnos WHERE creditos > frontera;
	
	RETURN suma;
END $
DELIMITER ;

DROP PROCEDURE IF EXISTS reparte;
DELIMITER $
CREATE PROCEDURE reparte(frontera INT)
BEGIN
	DECLARE suma INT;
	DECLARE mover INT;
	DECLARE creditos_actual INT;
	
	SET suma = creditos_repartir(frontera);
	UPDATE alumnos SET creditos = frontera WHERE creditos > frontera;
	
	CREATE TEMPORARY TABLE lista (
		creditos INT,
		cuenta INT,
		
		PRIMARY KEY (creditos)
	) ENGINE=memory;
	
	INSERT INTO lista (creditos, cuenta) SELECT creditos, COUNT(*) FROM alumnos WHERE creditos < frontera GROUP BY creditos;
	SELECT MIN(creditos) INTO creditos_actual FROM lista;
	
	WHILE creditos_actual < frontera AND suma > 0 DO
		SELECT LEAST(suma, cuenta) INTO mover FROM lista WHERE creditos = creditos_actual;
		
		UPDATE alumnos SET creditos = creditos + 1 WHERE creditos = creditos_actual LIMIT mover;
		INSERT INTO lista (creditos, cuenta) VALUES (creditos_actual + 1, mover) ON DUPLICATE KEY UPDATE cuenta = cuenta + mover;
		SET suma = suma - mover;
		
		SET creditos_actual = creditos_actual + 1;
	END WHILE;
END $
DELIMITER ;